diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.41/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.40/src/wifi/test/wifi-mac-ofdma-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/wifi-mac-ofdma-test.cc	2024-02-09 14:44:08.613795300 -0800
@@ -100,11 +100,12 @@
             .SetParent<MultiUserScheduler>()
             .SetGroupName("Wifi")
             .AddConstructor<TestMultiUserScheduler>()
-            .AddAttribute("ModulationClass",
-                          "Modulation class for DL MU PPDUs and TB PPDUs.",
-                          EnumValue(WIFI_MOD_CLASS_HE),
-                          MakeEnumAccessor(&TestMultiUserScheduler::m_modClass),
-                          MakeEnumChecker(WIFI_MOD_CLASS_HE, "HE", WIFI_MOD_CLASS_EHT, "EHT"));
+            .AddAttribute(
+                "ModulationClass",
+                "Modulation class for DL MU PPDUs and TB PPDUs.",
+                EnumValue(WIFI_MOD_CLASS_HE),
+                MakeEnumAccessor<WifiModulationClass>(&TestMultiUserScheduler::m_modClass),
+                MakeEnumChecker(WIFI_MOD_CLASS_HE, "HE", WIFI_MOD_CLASS_EHT, "EHT"));
     return tid;
 }
 
@@ -186,7 +187,8 @@
         m_txParams.Clear();
         // set the TXVECTOR used to send the Trigger Frame
         m_txParams.m_txVector =
-            m_apMac->GetWifiRemoteStationManager()->GetRtsTxVector(m_triggerHdr.GetAddr1());
+            m_apMac->GetWifiRemoteStationManager()->GetRtsTxVector(m_triggerHdr.GetAddr1(),
+                                                                   m_allowedWidth);
 
         if (!GetHeFem(SINGLE_LINK_OP_ID)->TryAddMpdu(item, m_txParams, m_availableTime) ||
             (m_availableTime != Time::Min() &&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-mlo-test.cc ns-3.41/src/wifi/test/wifi-mlo-test.cc
--- ns-3.40/src/wifi/test/wifi-mlo-test.cc	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wifi/test/wifi-mlo-test.cc	2024-02-09 14:44:08.613795300 -0800
@@ -613,7 +613,7 @@
 MultiLinkOperationsTestBase::DoSetup()
 {
     RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(2);
+    RngSeedManager::SetRun(3);
     int64_t streamNumber = 30;
 
     NodeContainer wifiApNode;
@@ -932,12 +932,14 @@
     MultiLinkOperationsTestBase::DoSetup();
 
     m_staMacs[0]->SetAttribute("ActiveProbing", BooleanValue(m_scanType == WifiScanType::ACTIVE));
-    m_apMac->GetEhtConfiguration()->SetAttribute("TidToLinkMappingNegSupport",
-                                                 EnumValue(m_apNegSupport));
+    m_apMac->GetEhtConfiguration()->SetAttribute(
+        "TidToLinkMappingNegSupport",
+        EnumValue(static_cast<WifiTidToLinkMappingNegSupport>(m_apNegSupport)));
     // For non-AP MLD, it does not make sense to set the negotiation type to 0 (unless the AP MLD
     // also advertises 0) or 1 (the AP MLD is discarded if it advertises a support of 3)
     auto staEhtConfig = m_staMacs[0]->GetEhtConfiguration();
-    staEhtConfig->SetAttribute("TidToLinkMappingNegSupport", EnumValue(3));
+    staEhtConfig->SetAttribute("TidToLinkMappingNegSupport",
+                               EnumValue(WIFI_TID_TO_LINK_MAPPING_ANY_LINK_SET));
     staEhtConfig->SetAttribute("TidToLinkMappingDl", StringValue(m_dlTidLinkMappingStr));
     staEhtConfig->SetAttribute("TidToLinkMappingUl", StringValue(m_ulTidLinkMappingStr));
 
@@ -2422,6 +2424,7 @@
     std::vector<PacketSocketAddress> m_sockets; ///< packet socket addresses for STAs
     std::size_t m_nPackets;                     ///< number of application packets to generate
     std::size_t m_blockAckCount{0};             ///< transmitted BlockAck counter
+    std::size_t m_tfCount{0};                   ///< transmitted Trigger Frame counter
     // std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
     std::map<AddrSeqNoPair, std::size_t> m_inflightCount; ///< max number of simultaneous
                                                           ///< transmissions of each data frame
@@ -2570,6 +2573,13 @@
                         GetApplication(m_sockets[i], m_nPackets, 450, txDuration, i * 4));
                 }
             }
+            if (++m_tfCount == m_staMacs[0]->GetSetupLinkIds().size())
+            {
+                // a TF has been sent on all the setup links, we can now disable UL OFDMA
+                auto muScheduler = m_apMac->GetObject<MultiUserScheduler>();
+                NS_TEST_ASSERT_MSG_NE(muScheduler, nullptr, "Expected an aggregated MU scheduler");
+                muScheduler->SetAttribute("EnableUlOfdma", BooleanValue(false));
+            }
             break;
         default:;
         }
@@ -2778,13 +2788,12 @@
     }
 
     // aggregate MU scheduler
-    auto muScheduler = CreateObjectWithAttributes<RrMultiUserScheduler>(
-        "EnableUlOfdma",
-        BooleanValue(m_muTrafficPattern == WifiMuTrafficPattern::UL_MU),
-        "EnableBsrp",
-        BooleanValue(false),
-        "UlPsduSize",
-        UintegerValue(2000));
+    auto muScheduler = CreateObjectWithAttributes<RrMultiUserScheduler>("EnableUlOfdma",
+                                                                        BooleanValue(false),
+                                                                        "EnableBsrp",
+                                                                        BooleanValue(false),
+                                                                        "UlPsduSize",
+                                                                        UintegerValue(2000));
     m_apMac->AggregateObject(muScheduler);
 
     // install post reception error model on all devices
@@ -2861,6 +2870,7 @@
         Simulator::Schedule(m_nStations * MilliSeconds(50), [this]() {
             auto muScheduler = m_apMac->GetObject<MultiUserScheduler>();
             NS_TEST_ASSERT_MSG_NE(muScheduler, nullptr, "Expected an aggregated MU scheduler");
+            muScheduler->SetAttribute("EnableUlOfdma", BooleanValue(true));
             muScheduler->SetAccessReqInterval(MilliSeconds(3));
             // channel access is requested only once
             muScheduler->SetAccessReqInterval(Seconds(0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-phy-cca-test.cc ns-3.41/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.40/src/wifi/test/wifi-phy-cca-test.cc	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wifi/test/wifi-phy-cca-test.cc	2024-02-09 14:44:08.613795300 -0800
@@ -812,7 +812,7 @@
     std::size_t
         m_numSignalGenerators; ///< The number of non-wifi signals generators needed for the test
 
-    std::unique_ptr<CcaTestPhyListener>
+    std::shared_ptr<CcaTestPhyListener>
         m_rxPhyStateListener; ///< Listener for PHY state transitions
 
     uint16_t m_frequency;    ///< Operating frequency in MHz
@@ -1018,7 +1018,7 @@
     rxDev->SetVhtConfiguration(vhtConfiguration);
     m_rxPhy = CreateObject<SpectrumWifiPhy>();
     m_rxPhyStateListener = std::make_unique<CcaTestPhyListener>();
-    m_rxPhy->RegisterListener(m_rxPhyStateListener.get());
+    m_rxPhy->RegisterListener(m_rxPhyStateListener);
     Ptr<InterferenceHelper> rxInterferenceHelper = CreateObject<InterferenceHelper>();
     m_rxPhy->SetInterferenceHelper(rxInterferenceHelper);
     Ptr<ErrorRateModel> rxErrorModel = CreateObject<NistErrorRateModel>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.41/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.40/src/wifi/test/wifi-phy-ofdma-test.cc	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wifi/test/wifi-phy-ofdma-test.cc	2024-02-09 14:44:08.617795200 -0800
@@ -822,13 +822,13 @@
                                                                       WIFI_PHY_BAND_5GHZ));
 
     m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta1->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta2->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta3->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
     Simulator::Schedule(Seconds(0.5), &TestDlOfdmaPhyTransmission::ResetResults, this);
 
@@ -1922,7 +1922,7 @@
                                                                       WIFI_STANDARD_80211ax,
                                                                       WIFI_PHY_BAND_5GHZ));
     m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     m_phyAp->SetDevice(apDev);
     m_phyAp->TraceConnectWithoutContext("TxPpduUid",
                                         MakeCallback(&TestUlOfdmaPpduUid::TxPpduAp, this));
@@ -1944,7 +1944,7 @@
     m_phySta1->AddChannel(spectrumChannel);
     m_phySta1->ConfigureStandard(WIFI_STANDARD_80211ax);
     m_phySta1->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta1->SetDevice(sta1Dev);
     m_phySta1->TraceConnectWithoutContext("TxPpduUid",
                                           MakeCallback(&TestUlOfdmaPpduUid::TxPpduSta1, this));
@@ -1964,7 +1964,7 @@
     m_phySta2->AddChannel(spectrumChannel);
     m_phySta2->ConfigureStandard(WIFI_STANDARD_80211ax);
     m_phySta2->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta2->SetDevice(sta2Dev);
     m_phySta2->TraceConnectWithoutContext("TxPpduUid",
                                           MakeCallback(&TestUlOfdmaPpduUid::TxPpduSta2, this));
@@ -3180,7 +3180,7 @@
     Ptr<OfdmaSpectrumWifiPhy> m_phySta2; ///< PHY of STA 2
     Ptr<OfdmaSpectrumWifiPhy> m_phySta3; ///< PHY of STA 3
 
-    std::unique_ptr<OfdmaTestPhyListener>
+    std::shared_ptr<OfdmaTestPhyListener>
         m_apPhyStateListener; ///< listener for AP PHY state transitions
 
     Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
@@ -3735,7 +3735,7 @@
     Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel>();
     m_phyAp->SetMobility(apMobility);
     m_apPhyStateListener = std::make_unique<OfdmaTestPhyListener>();
-    m_phyAp->RegisterListener(m_apPhyStateListener.get());
+    m_phyAp->RegisterListener(m_apPhyStateListener);
     apDev->SetPhy(m_phyAp);
     apMac->SetWifiPhys({m_phyAp});
     apNode->AggregateObject(apMobility);
@@ -4124,13 +4124,13 @@
                                                                       WIFI_PHY_BAND_5GHZ));
 
     m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta1->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta2->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
     m_phySta3->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, m_channelWidth, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
     Time delay = Seconds(0.0);
     Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::Reset, this);
@@ -5095,7 +5095,7 @@
                                                                       WIFI_PHY_BAND_5GHZ));
 
     m_phyAp->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     m_phyAp->SetReceiveOkCallback(MakeCallback(&TestPhyPaddingExclusion::RxSuccess, this));
     m_phyAp->SetReceiveErrorCallback(MakeCallback(&TestPhyPaddingExclusion::RxFailure, this));
     Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel>();
@@ -5119,7 +5119,7 @@
     m_phySta1->ConfigureStandard(WIFI_STANDARD_80211ax);
     m_phySta1->AssignStreams(streamNumber);
     m_phySta1->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_phySta1->SetMobility(sta1Mobility);
     sta1Dev->SetPhy(m_phySta1);
@@ -5140,7 +5140,7 @@
     m_phySta2->ConfigureStandard(WIFI_STANDARD_80211ax);
     m_phySta2->AssignStreams(streamNumber);
     m_phySta2->SetOperatingChannel(
-        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, (int)(WIFI_PHY_BAND_5GHZ), 0});
+        WifiPhy::ChannelTuple{channelNum, DEFAULT_CHANNEL_WIDTH, WIFI_PHY_BAND_5GHZ, 0});
     Ptr<ConstantPositionMobilityModel> sta2Mobility = CreateObject<ConstantPositionMobilityModel>();
     m_phySta2->SetMobility(sta2Mobility);
     sta2Dev->SetPhy(m_phySta2);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-primary-channels-test.cc ns-3.41/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.40/src/wifi/test/wifi-primary-channels-test.cc	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wifi/test/wifi-primary-channels-test.cc	2024-02-09 14:44:08.617795200 -0800
@@ -390,7 +390,7 @@
                 "WaitBeaconTimeout",
                 TimeValue(MicroSeconds(102400))); // same as BeaconInterval
 
-    TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue> channelValue;
 
     // Each BSS uses a distinct primary20 channel
     for (uint8_t bss = 0; bss < m_nBss; bss++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-test.cc ns-3.41/src/wifi/test/wifi-test.cc
--- ns-3.40/src/wifi/test/wifi-test.cc	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wifi/test/wifi-test.cc	2024-02-09 14:44:08.617795200 -0800
@@ -328,7 +328,7 @@
 InterferenceHelperSequenceTest::SwitchCh(Ptr<WifiNetDevice> dev)
 {
     Ptr<WifiPhy> p = dev->GetPhy();
-    p->SetOperatingChannel(WifiPhy::ChannelTuple{40, 0, (int)(WIFI_PHY_BAND_5GHZ), 0});
+    p->SetOperatingChannel(WifiPhy::ChannelTuple{40, 0, WIFI_PHY_BAND_5GHZ, 0});
 }
 
 Ptr<Node>
@@ -1772,8 +1772,8 @@
 void
 Bug2831TestCase::ChangeSupportedChannelWidth()
 {
-    m_apPhy->SetOperatingChannel(WifiPhy::ChannelTuple{38, 40, (int)(WIFI_PHY_BAND_5GHZ), 0});
-    m_staPhy->SetOperatingChannel(WifiPhy::ChannelTuple{38, 40, (int)(WIFI_PHY_BAND_5GHZ), 0});
+    m_apPhy->SetOperatingChannel(WifiPhy::ChannelTuple{38, 40, WIFI_PHY_BAND_5GHZ, 0});
+    m_staPhy->SetOperatingChannel(WifiPhy::ChannelTuple{38, 40, WIFI_PHY_BAND_5GHZ, 0});
 }
 
 void
@@ -1843,7 +1843,7 @@
     m_apPhy->SetMobility(apMobility);
     m_apPhy->SetDevice(apDev);
     m_apPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    m_apPhy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, (int)(WIFI_PHY_BAND_5GHZ), 0});
+    m_apPhy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, WIFI_PHY_BAND_5GHZ, 0});
 
     ObjectFactory mac;
     mac.SetTypeId("ns3::ApWifiMac");
@@ -1884,7 +1884,7 @@
     m_staPhy->SetMobility(staMobility);
     m_staPhy->SetDevice(apDev);
     m_staPhy->ConfigureStandard(WIFI_STANDARD_80211ax);
-    m_staPhy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, (int)(WIFI_PHY_BAND_5GHZ), 0});
+    m_staPhy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, WIFI_PHY_BAND_5GHZ, 0});
 
     mac.SetTypeId("ns3::StaWifiMac");
     auto staMac = mac.Create<WifiMac>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/CMakeLists.txt ns-3.41/src/wimax/CMakeLists.txt
--- ns-3.40/src/wimax/CMakeLists.txt	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wimax/CMakeLists.txt	2024-02-09 14:44:08.617795200 -0800
@@ -100,11 +100,8 @@
   LIBNAME wimax
   SOURCE_FILES ${source_files}
   HEADER_FILES ${header_files}
-  LIBRARIES_TO_LINK
-    ${libnetwork}
-    ${libinternet}
-    ${libpropagation}
-    ${libmobility}
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libpropagation}
   TEST_SOURCES
     test/mac-messages-test.cc
     test/phy-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/bs-net-device.h ns-3.41/src/wimax/model/bs-net-device.h
--- ns-3.40/src/wimax/model/bs-net-device.h	2023-09-27 13:30:37.926839800 -0700
+++ ns-3.41/src/wimax/model/bs-net-device.h	2024-02-09 14:44:08.621795200 -0800
@@ -492,7 +492,7 @@
      * \see class CallBackTraceSource
      */
     TracedCallback<Ptr<const Packet>>
-        m_bsPromiscRxTrace; ///< base station promiscious receive trace callback
+        m_bsPromiscRxTrace; ///< base station promiscuous receive trace callback
 
     /**
      * The trace source fired for packets successfully received by the device
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/ipcs-classifier-record.cc ns-3.41/src/wimax/model/ipcs-classifier-record.cc
--- ns-3.40/src/wimax/model/ipcs-classifier-record.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/ipcs-classifier-record.cc	2024-02-09 14:44:08.621795200 -0800
@@ -332,7 +332,7 @@
     ProtocolTlvValue protoVal;
     for (auto iter = m_protocol.begin(); iter != m_protocol.end(); ++iter)
     {
-        protoVal.Add((*iter));
+        protoVal.Add(*iter);
     }
 
     PortRangeTlvValue portValueSrc;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/service-flow-manager.cc ns-3.41/src/wimax/model/service-flow-manager.cc
--- ns-3.40/src/wimax/model/service-flow-manager.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/service-flow-manager.cc	2024-02-09 14:44:08.621795200 -0800
@@ -96,7 +96,7 @@
         {
             if ((*iter)->CheckClassifierMatch(srcAddress, dstAddress, srcPort, dstPort, proto))
             {
-                return (*iter);
+                return *iter;
             }
         }
     }
@@ -110,7 +110,7 @@
     {
         if ((*iter)->GetSfid() == sfid)
         {
-            return (*iter);
+            return *iter;
         }
     }
 
@@ -125,7 +125,7 @@
     {
         if ((*iter)->GetCid() == cid.GetIdentifier())
         {
-            return (*iter);
+            return *iter;
         }
     }
 
@@ -142,7 +142,7 @@
         if (((*iter)->GetSchedulingType() == schedulingType) ||
             (schedulingType == ServiceFlow::SF_TYPE_ALL))
         {
-            tmpServiceFlows.push_back((*iter));
+            tmpServiceFlows.push_back(*iter);
         }
     }
     return tmpServiceFlows;
@@ -180,7 +180,7 @@
     {
         if (!(*iter)->GetIsEnabled())
         {
-            return (*iter);
+            return *iter;
         }
     }
     return nullptr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/ss-net-device.cc ns-3.41/src/wimax/model/ss-net-device.cc
--- ns-3.40/src/wimax/model/ss-net-device.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/ss-net-device.cc	2024-02-09 14:44:08.625795400 -0800
@@ -54,7 +54,7 @@
 Time
 SubscriberStationNetDevice::GetDefaultLostDlMapInterval()
 {
-    return (MicroSeconds(500000));
+    return MicroSeconds(500000);
 }
 
 TypeId
@@ -745,7 +745,7 @@
                           "Error while enqueuing  packet: incorrect header type");
 
             GrantManagementSubheader grantMgmntSubhdr;
-            grantMgmntSubhdr.SetPm(true);
+            grantMgmntSubhdr.SetPm(1);
             packet->AddHeader(grantMgmntSubhdr);
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/ss-record.cc ns-3.41/src/wimax/model/ss-record.cc
--- ns-3.40/src/wimax/model/ss-record.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/ss-record.cc	2024-02-09 14:44:08.625795400 -0800
@@ -238,7 +238,7 @@
         if (((*iter)->GetSchedulingType() == schedulingType) ||
             (schedulingType == ServiceFlow::SF_TYPE_ALL))
         {
-            tmpServiceFlows.push_back((*iter));
+            tmpServiceFlows.push_back(*iter);
         }
     }
     return tmpServiceFlows;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/wimax-connection.cc ns-3.41/src/wimax/model/wimax-connection.cc
--- ns-3.40/src/wimax/model/wimax-connection.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/wimax-connection.cc	2024-02-09 14:44:08.625795400 -0800
@@ -43,7 +43,7 @@
                             .AddAttribute("Type",
                                           "Connection type",
                                           EnumValue(Cid::INITIAL_RANGING),
-                                          MakeEnumAccessor(&WimaxConnection::GetType),
+                                          MakeEnumAccessor<Cid::Type>(&WimaxConnection::GetType),
                                           MakeEnumChecker(Cid::BROADCAST,
                                                           "Broadcast",
                                                           Cid::INITIAL_RANGING,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/wimax-mac-header.cc ns-3.41/src/wimax/model/wimax-mac-header.cc
--- ns-3.40/src/wimax/model/wimax-mac-header.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/wimax-mac-header.cc	2024-02-09 14:44:08.625795400 -0800
@@ -325,7 +325,7 @@
 bool
 GenericMacHeader::check_hcs() const
 {
-    return (m_hcs == c_hcs);
+    return m_hcs == c_hcs;
 }
 
 // ----------------------------------------------------------------------------------------------------------
@@ -527,7 +527,7 @@
 bool
 BandwidthRequestHeader::check_hcs() const
 {
-    return (m_hcs == c_hcs);
+    return m_hcs == c_hcs;
 }
 
 // ----------------------------------------------------------------------------------------------------------
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/wimax-net-device.h ns-3.41/src/wimax/model/wimax-net-device.h
--- ns-3.40/src/wimax/model/wimax-net-device.h	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/wimax-net-device.h	2024-02-09 14:44:08.625795400 -0800
@@ -211,7 +211,7 @@
 
     /**
      * Set the connection manager of the device
-     * \param  connectionManager the commection manager to be installed in the device
+     * \param  connectionManager the connection manager to be installed in the device
      */
     virtual void SetConnectionManager(Ptr<ConnectionManager> connectionManager);
 
@@ -421,13 +421,13 @@
                   const Address& dest,
                   uint16_t protocolNumber) override;
     /**
-     * Set promiscious receive callback function
-     * \param cb the promiscious mode callback
+     * Set promiscuous receive callback function
+     * \param cb the promiscuous mode callback
      */
     void SetPromiscReceiveCallback(PromiscReceiveCallback cb) override;
     /**
-     * Get promiscious receive callback function
-     * \returns the promiscious mode callback
+     * Get promiscuous receive callback function
+     * \returns the promiscuous mode callback
      */
     NetDevice::PromiscReceiveCallback GetPromiscReceiveCallback();
     /**
@@ -470,12 +470,12 @@
     bool IsBridge() const override;
 
     /**
-     * Check if device is promiscious
-     * \returns true if promiscious
+     * Check if device is promiscuous
+     * \returns true if promiscuous
      */
     bool IsPromisc();
     /**
-     * Notify promiscious trace of a packet arrival
+     * Notify promiscuous trace of a packet arrival
      * \param p the packet
      */
     void NotifyPromiscTrace(Ptr<Packet> p);
@@ -527,7 +527,7 @@
     Ptr<Node> m_node;                              ///< the node
     Ptr<WimaxPhy> m_phy;                           ///< the phy
     NetDevice::ReceiveCallback m_forwardUp;        ///< forward up callback function
-    NetDevice::PromiscReceiveCallback m_promiscRx; ///< promiscious receive fcallback function
+    NetDevice::PromiscReceiveCallback m_promiscRx; ///< promiscuous receive callback function
 
     uint32_t m_ifIndex;          ///< IF index
     std::string m_name;          ///< service name
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/model/wimax-tlv.cc ns-3.41/src/wimax/model/wimax-tlv.cc
--- ns-3.40/src/wimax/model/wimax-tlv.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/model/wimax-tlv.cc	2024-02-09 14:44:08.625795400 -0800
@@ -966,7 +966,7 @@
 {
     for (auto iter = m_protocol->begin(); iter != m_protocol->end(); ++iter)
     {
-        i.WriteU8((*iter));
+        i.WriteU8(*iter);
     }
 }
 
@@ -1006,7 +1006,7 @@
     auto tmp = new ProtocolTlvValue();
     for (auto iter = m_protocol->begin(); iter != m_protocol->end(); ++iter)
     {
-        tmp->Add((*iter));
+        tmp->Add(*iter);
     }
     return tmp;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wimax/test/phy-test.cc ns-3.41/src/wimax/test/phy-test.cc
--- ns-3.40/src/wimax/test/phy-test.cc	2023-09-27 13:30:37.930839800 -0700
+++ ns-3.41/src/wimax/test/phy-test.cc	2024-02-09 14:44:08.625795400 -0800
@@ -103,7 +103,7 @@
         }
     }
     Simulator::Destroy();
-    return (false); // Test was ok, all the SSs are registered
+    return false; // Test was ok, all the SSs are registered
 }
 
 void
